indexing
	description: "Description of class"
	date: "$Date: Dec 27, 2006 7:43:44 PM$"
	revision: "$Revision: 1.0$"

class EM3D_FONT_TEXTURE_2D[F -> EMGL_FORMAT create default_create end]

inherit
	EM3D_TEXTURE_2D[F]
		redefine
			update_texture
		end

	EM_CONSTANTS
		export {NONE} all
		undefine default_create end

	EM_SHARED_BITMAP_FACTORY
		export {NONE} all
		undefine default_create end

create
	make_with_font, make_with_font_mipmap

feature {NONE} -- Initialization

	make_with_font( a_font: EM_TTF_FONT ) is
			-- Create a new EM3D_FONT_TEXTURE object.
		require
			a_font_not_empty: a_font /= void
		do
			make_empty(2,2)
			font := a_font
			create background_color.make_black
		ensure
			font_set: font = a_font
		end

	make_with_font_mipmap( a_font: EM_TTF_FONT ) is
			-- Create a new EM3D_FONT_TEXTURE object.
		require
			a_font_not_empty: a_font /= void
		do
			make_empty_mipmap(2,2)
			font := a_font
			create background_color.make_black
		ensure
			font_set: font = a_font
		end

feature -- Status
	font: EM_TTF_FONT
	text: STRING
	set_text (a_text: STRING) is
				-- Set `text' to `a_text'.
		require
			a_text_not_void: a_text /= Void
		do
			text := a_text
		ensure
			definition_of_set_text: text = a_text
			text_not_void: text /= Void
		end
	background_color: EM_COLOR
	set_background_color (a_background_color: EM_COLOR) is
				-- Set `background_color' to `a_background_color'.
		require
			a_background_color_not_void: a_background_color /= Void
		do
			background_color := a_background_color
		ensure
			definition_of_set_background_color: background_color = a_background_color
			background_color_not_void: background_color /= Void
		end


feature {NONE} --Implementation
	internal_text: STRING
	internal_background_color: EM_COLOR
	update_texture is
			-- update the texture if needed
		local
			surface: EM_SURFACE
			w,h: INTEGER
		do
			if text /= void and then ( ( internal_text = void or else not text.is_equal( internal_text )) or
					internal_background_color=void or else not background_color.is_equal(internal_background_color)) then
				internal_text := text.twin
				internal_background_color := background_color.twin
				w := font.string_width( internal_text )
				h := font.string_height( internal_text )
				Bitmap_factory.create_empty_surface (w, h)
				surface := Bitmap_factory.last_surface
				surface.fill ( internal_background_color )
				font.draw_string( internal_text, surface, 0, 0 )
				if is_mipmap then
					make_mipmap_from_surface_stretched( surface )
				else
					make_from_surface_stretched( surface )
				end
			end
		end

end -- class EM3D_FONT_TEXTURE_2D
